﻿using Sfs2X.Protocol.Serialization;
using System;

namespace sfs2x.extension.test.serialization.model
{
    interface Spell
    {
        string GetId();
        void SetId(string id);

        int GetHitPoints();
        void SetHitPoints(int hitPoints);

        int Count();
        void Cast();
    }

    class WaterFloodSpell : Spell, SerializableSFSType
    {
        public string id;
        public int hitPoints;
        public int count;

        public string GetId() { return id; }
        public void SetId(string id) { this.id = id; }

        public int GetHitPoints() { return hitPoints; }
        public void SetHitPoints(int hitPoints) { this.hitPoints = hitPoints; }

        public int Count() { return count; }

        public WaterFloodSpell() { }
        public WaterFloodSpell(string id = null, int hitPoints = 70)
        {
            this.id = id;
            this.hitPoints = hitPoints;
        }

        public void Cast()
        {
            Console.WriteLine("Casting " + id);
        }
    }

    class SolarVortexSpell : Spell, SerializableSFSType
    {
        public string id;
        public int hitPoints;
        public int count;

        public string GetId() { return id; }
        public void SetId(string id) { this.id = id; }

        public int GetHitPoints() { return hitPoints; }
        public void SetHitPoints(int hitPoints) { this.hitPoints = hitPoints; }

        public int Count() { return count; }

        public SolarVortexSpell() { }
        public SolarVortexSpell(string id = null, int hitPoints = 180)
        {
            this.id = id;
            this.hitPoints = hitPoints;
        }

        public void Cast()
        {
            Console.WriteLine("Casting " + id);
        }
    }

    class DeathRaySpell : Spell, SerializableSFSType
    {
        public string id;
        public int hitPoints;
        public int count;

        public string GetId() { return id; }
        public void SetId(string id) { this.id = id; }

        public int GetHitPoints() { return hitPoints; }
        public void SetHitPoints(int hitPoints) { this.hitPoints = hitPoints; }

        public int Count() { return count; }

        public DeathRaySpell() { }
        public DeathRaySpell(string id = null, int hitPoints = 10)
        {
            this.id = id;
            this.hitPoints = hitPoints;
        }

        public void Cast()
        {
            Console.WriteLine("Casting " + id);
        }
    }

    class RisingFlamesSpell : Spell, SerializableSFSType
    {
        public string id;
        public int hitPoints;
        public int count;

        public string GetId() { return id; }
        public void SetId(string id) { this.id = id; }

        public int GetHitPoints() { return hitPoints; }
        public void SetHitPoints(int hitPoints) { this.hitPoints = hitPoints; }

        public int Count() { return count; }

        public RisingFlamesSpell() { }
        public RisingFlamesSpell(string id = null, int hitPoints = 45)
        {
            this.id = id;
            this.hitPoints = hitPoints;
        }

        public void Cast()
        {
            Console.WriteLine("Casting " + id);
        }
    }

    class SpiderSwarmSpell : Spell, SerializableSFSType
    {
        public string id;
        public int hitPoints;
        public int count;

        public string GetId() { return id; }
        public void SetId(string id) { this.id = id; }

        public int GetHitPoints() { return hitPoints; }
        public void SetHitPoints(int hitPoints) { this.hitPoints = hitPoints; }

        public int Count() { return count; }

        public SpiderSwarmSpell() { }
        public SpiderSwarmSpell(string id = null, int hitPoints = 35)
        {
            this.id = id;
            this.hitPoints = hitPoints;
        }

        public void Cast()
        {
            Console.WriteLine("Casting " + id);
        }
    }
}
